std::is_member_pointer(3)

NAME
std::is_member_pointer - std::is_member_pointer

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_member_pointer;
   std::is_member_pointer is a UnaryTypeTrait.
   If T is pointer to non-static member object or a pointer to non-static member
   function, provides the member constant value equal true. For any other type, value
   is false.
   If the program adds specializations for std::is_member_pointer or
   std::is_member_pointer_v, the behavior is undefined.

Template parameters
   T - a type to check
   Helper variable template
   template< class T >
   inline constexpr bool is_member_pointer_v = (since C++17)
   is_member_pointer<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a member pointer type, false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
 template<class T>
 struct is_member_pointer_helper : std::false_type {};
 template<class T, class U>
 struct is_member_pointer_helper<T U::*> : std::true_type {};
 template<class T>
 struct is_member_pointer : is_member_pointer_helper<typename std::remove_cv<T>::type> {};

Example
// Run this code
 #include <type_traits>
 class C {};
 static_assert(std::is_member_pointer_v<int(C::*)>);
 static_assert(!std::is_member_pointer_v<int>);
 int main()
 {
 }

See also
   is_pointer checks if a type is a pointer type
   (C++11) (class template)
   is_member_object_pointer checks if a type is a pointer to a non-static member
   (C++11) object
                        (class template)
   is_member_function_pointer checks if a type is a pointer to a non-static member
   (C++11) function
                        (class template)